(function($) {
	/**
	 * Represents the loading animation.
	 */
	Loadinganimation = function(context, settings) {
		this.settings = settings;
		this._init = function(context) {			
			// Anwenden auf alle Links außer JS-Links, interne Links und solche
			// mit der Klasse ".noLoadingAnimation"
			if(settings.subselector != ''){
				var subselectorSuffix = ' ' + settings.subselector;
			} else {
				var subselectorSuffix = '';
			}
			if (Drupal.settings.jquery_loadinganimation.show_on_href) {
				$(context).find("a[href]" + settings.subselector).not(
						"a[href=javascript:;]").not("a[href=#]").not(".noLoadingAnimation").each(
						function(i, element) {
							// Nur Elemente, die keine JS-Events haben (TODO: Nur
							// click-events beachten)
							if (typeof $(element).data("events") == 'undefined'
									|| $(element).data("events").length == 0) {
								$(element).click(function(eventObject) {
									// Nicht bei Öffnen in neuem Tab (Strg+Klick)
									if (!eventObject.ctrlKey) {
										Drupal.behaviors.jquery_loadinganimation.Loadinganimation.show();
									}
								});
							}
						});
			}

			if (Drupal.settings.jquery_loadinganimation.show_on_form_submit) {
				// Bei Formularversand auch ausfuehren, wenn keine anderen Events
				// registriert sind.
				$(context).find("form" + subselectorSuffix).submit(
						function() {
							if (typeof $(this).data("events") == 'undefined'
									|| $(this).data("events").length == 0
									) {
								Drupal.behaviors.jquery_loadinganimation.Loadinganimation.show();
							} else {
								var show=true;
								jQuery.each($(this).data("events"), function(index, element){
									if(element.type != undefined){
										show = false;
									}
								});
								if(show){
									Drupal.behaviors.jquery_loadinganimation.Loadinganimation.show();
								}
							}
						});
			}

			// Bei Klick auf die Animation ausblenden
			$("div#loadinganimation").click(function() {
				Drupal.behaviors.jquery_loadinganimation.Loadinganimation.hide();
			});

			// Bei ESC wieder ausblenden
			document.onkeydown = function(e) {
				if (e == null) { // ie
					keycode = event.keyCode;
				} else { // mozilla
					keycode = e.which;
				}
				if (keycode == 27) { // escape, close box
					Drupal.behaviors.jquery_loadinganimation.Loadinganimation.hide();
				}
			};
		};
		
		// Initialize!
		this._init(context);
		
		// Register global Drupal.behaviors.jquery_loadinganimation.Loadinganimation object after init!
		Drupal.behaviors.jquery_loadinganimation.Loadinganimation = this;
		
		// Preload images.
		jQuery.preLoadImages(Drupal.settings.basePath + Drupal.settings.jquery_loadinganimation.img_src);

		/**
		 * Zeigt die Ladegrafik als Layer über der Seite.
		 */
		this.show = function() {
			// Nur einblenden, wenn nicht bereits eingeblendet!
			if ($("div#loadinganimation").length == 0) {
				$("body")
						.append(
								'<div id="loadinganimation"><div class="border top"></div><div class="inner"><img class="first" src="'
										+ Drupal.settings.basePath + Drupal.settings.jquery_loadinganimation.img_src
										+ '" alt="'
										+ Drupal.t('Loading')
										+ '..." /><img class="second" src="'
										+ Drupal.settings.basePath + Drupal.settings.jquery_loadinganimation.img_src
										+ '" alt="'
										+ Drupal.t('Loading')
										+ '..." /><img class="third" src="'
										+ Drupal.settings.basePath + Drupal.settings.jquery_loadinganimation.img_src
										+ '" alt="'
										+ Drupal.t('Loading')
										+ '..." /><br />'
										+ Drupal.t('Loading')
										+ '...</div><div class="border bottom"></div></div>');
			}
		};

		/**
		 * Versteckt die Ladegrafik über der Seite.
		 */
		this.hide = function() {
			$("div#loadinganimation").remove();
		};
	};
	
	/**
	 * JQuery image preloader script
	 * from http://engineeredweb.com/blog/09/12/preloading-images-jquery-and-javascript
	 */
	(function($) {
	  var cache = [];
	  // Arguments are image paths relative to the current page.
	  $.preLoadImages = function() {
	    var args_len = arguments.length;
	    for (var i = args_len; i--;) {
	      var cacheImage = document.createElement('img');
	      cacheImage.src = arguments[i];
	      cache.push(cacheImage);
	    }
	  };
	})(jQuery);

	/**
	 * Initialization
	 */
	Drupal.behaviors.jquery_loadinganimation = {
		/**
		 * Run Drupal module JS initialization.
		 * 
		 * @param context
		 * @param settings
		 */
	    attach : function(context, settings) {
          // Initialize general loading animation.
          Drupal.behaviors.jquery_loadinganimation.Loadinganimation = new Loadinganimation(context, settings.jquery_loadinganimation);
          if (context == document) {
              // Global context!
              if (settings.jquery_loadinganimation.show_on_ajax) {
                  // Register loading animations for ajax events!
                  $(context).ajaxSend(function() {
                      // Show loading animation on request.
                      Drupal.behaviors.jquery_loadinganimation.Loadinganimation.show();
                  });

                  $(context).ajaxSuccess(function() {
                      // Hide loading animation after finish.
                      Drupal.behaviors.jquery_loadinganimation.Loadinganimation.hide();
                  });
              }
           }
        }
	};
})(jQuery);